#include "pci429-4.h"

//

#define KVP(hDevice,Data,adr)	Data[0] =0x2;	\
			Data[1] = (unsigned short)adr;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data)

#define KPP(hDevice,Data,adr,prm)	Data[0] =0x3;	\
			Data[1] = (unsigned short)adr;\
			Data[2] = (unsigned short)(prm&0xffff);\
			Data[3] = (unsigned short)(((prm)>>16)&0xffff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_3,&Data )


#define KMP(hDevice,Data) Data[0] = 0x4;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KCB(hDevice,Data,msk)	Data[0] = 0x5;\
			Data[1] = (unsigned short)msk;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )

#define KCT(hDevice,Data) Data[0]=0x6;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
			
	
#define KPT(hDevice,Data,tmr)	Data[0] = 0x7; Data[1] = (unsigned short)tmr;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )


#define KVM0(hDevice,Data )	Data[0] = 0x8;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM1(hDevice,Data )	Data[0] = 0x9;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM2(hDevice,Data )	Data[0] = 0xA;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM3(hDevice,Data )	Data[0] = 0xB;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM4(hDevice,Data )	Data[0] = 0xC;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM5(hDevice,Data )	Data[0] = 0xD;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM6(hDevice,Data )	Data[0] = 0xE;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )
#define KVM7(hDevice,Data )	Data[0] = 0xF;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )


//     

#define KP_PFA_BKP(hDevice,Data ,nc,ch,m_ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = ((m_ch&1)<<15)|(ch&0x3ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )

#define KP_PFA_BKP2(hDevice,Data ,nc,ch,m_ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = ((m_ch&1)<<15)|(0x400)|(ch&0x1ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )

#define KP_PFR_BKP(hDevice,Data ,nc,ch,m_ch)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = ((m_ch&1)<<15)|(0x1000)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KP_PFR_BKP2(hDevice,Data ,nc,ch,m_ch)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = ((m_ch&1)<<15)|(0x1400)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KP_PFC_BKP(hDevice,Data ,nc,ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = (0x1800)|(ch&0x3ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )
#define KP_PFC_BKP2(hDevice,Data ,nc,ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = (0x1C00)|(ch&0x1ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )
#define KP_PA_BKP1(hDevice,Data ,nc,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = 0x2000;\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )
#define KP_PA_BKP2(hDevice,Data ,nc,ap,m_ap)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = 0x2400;\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )
#define KP_PG(hDevice,Data ,nc)	Data[0] =((nc-1)&0xF)+0x10;	\
			Data[1] = 0x3000;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )



//    
#define KV_VR_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VR_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0x400)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VC_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0x800)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VC_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0xC00)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VO_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0x1800)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VO_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0x1C00)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )
#define KV_VG(hDevice,Data ,nc,m)	Data[0] =((nc-1)&0xF)+0x20;	\
			Data[1] = ((m&1)<<15)|(0x2000);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_1,&Data )

//   
#define KOM(hDevice,Data ,am,ch)	Data[0] =0x30;	\
			Data[1] = (unsigned short)am;\
			Data[2] = (unsigned short)ch;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )
#define KOMP(hDevice,Data ,am,ch)	Data[0] =0x31;	\
			Data[1] = (unsigned short)am;\
			Data[2] = (unsigned short)ch;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_2,&Data )

//   
#define KPM0(hDevice,Data )	Data[0] = 0x38;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM1(hDevice,Data )	Data[0] = 0x39;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM2(hDevice,Data )	Data[0] = 0x3A;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM3(hDevice,Data )	Data[0] = 0x3B;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM4(hDevice,Data )	Data[0] = 0x3C;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM5(hDevice,Data )	Data[0] = 0x3D;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM6(hDevice,Data )	Data[0] = 0x3E;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )

#define KPM7(hDevice,Data )	Data[0] = 0x3F;	\
			ioctl(hDevice,LNXioctl_PCI429_4_writeKOP_0,&Data )


//
#define PFA_BKP(hDevice,Data ,nc,ch,m_ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m_ch&1)<<15)|(ch&0x3ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PFA_BKP2(hDevice,Data ,nc,ch,m_ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m_ch&1)<<15)|(0x400)|(ch&0x1ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PFR_BKP(hDevice,Data ,nc,ch,m_ch)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m_ch&1)<<15)|(0x1000)|(ch&0x3ff);\
			Data[2] = 0;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PFR_BKP2(hDevice,Data ,nc,ch,m_ch)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m_ch&1)<<15)|(0x1400)|(ch&0x1ff);\
			Data[2] = 0;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PFC_BKP(hDevice,Data ,nc,ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = (0x1800)|(ch&0x3ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PFC_BKP2(hDevice,Data ,nc,ch,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = (0x1C00)|(ch&0x1ff);\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PA_BKP1(hDevice,Data ,nc,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = 0x2000;\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PA_BKP2(hDevice,Data ,nc,ap,m_ap)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = 0x2400;\
			Data[2] = (unsigned short)(((m_ap&1)<<13)|(ap&0xff));\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )
#define PG(hDevice,Data ,nc)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = 0x3000;\
			Data[2] = 0;\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_I,&Data )



//
#define VR_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VR_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0x400)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VC_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0x800)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VC_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0xC00)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VO_BKV(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0x1800)|(ch&0x3ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VO_BKV2(hDevice,Data ,nc,ch,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0x1C00)|(ch&0x1ff);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )
#define VG(hDevice,Data ,nc,m)	Data[0] =((nc-1)&0xF)+1;	\
			Data[1] = ((m&1)<<15)|(0x2000);\
			ioctl(hDevice,LNXioctl_PCI429_4_writeBU_O,&Data )

//  ,    .

// .

#define TAB_VG_WORD(Data,ss,adr,km,nl)	Data[ss+2] =((km&0x1)<<14)+((nl&0x1)<<13)+(adr&0x1fff)


#define TAB_VG_PAUSE(Data, ss, ch_p)	Data[ss+2] =(ch_p&0x1FF)+0x8000

// .

#define TAB_PG_WORD(Data,ap,adr,m)	Data[ap+2] =((m&0x1)<<15)+0x2000+(adr&0x1fff)


#define TAB_PG_PAUSE(Data, ap)	Data[ap+2] =0
